#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"

// LED_/p}N
#define ON 0x00
#define OFF 0xFF
// LED_p^[p}N
#define Pattern_1 0xFF
#define Pattern_2 0x00
#define Pattern_3 0xF0
#define Pattern_4 0x0F

// SWƂŁALED̓_p^[ύX
void main(void)
{
	// ҂ԗp
	volatile unsigned long Loop;
	// LED_p^[
	char State;	
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |
                   SYSCTL_XTAL_6MHZ);
    
    // gp|[g̐錾@LEDpɃ|[gCƃ|[gDgp
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
    // gp|[g̐錾@SWpɃ|[gBgp
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
    
    // PD0`PD6,PC7ꂼo̓^Cvɐݒ
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_1);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_2);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_5);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_7);
    
    // PB0,PB1,PB4,PB5vAbv̓^Cvɐݒ
    GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_1);
    GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_5);
    
    // _p^[lZbg
    State = 0x00;
    
    while(1)
    {
    	// ǂSWꂽ
    	if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_0) == 0)
    	{
    		// _p^[Zbg
    		State = Pattern_1;
    		// `^O΍p҂
    		for(Loop = 0; Loop < 200000; Loop++);
    	}
    	else if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_1) == 0)
    	{
    		// _p^[Zbg
    		State = Pattern_2;
    		// `^O΍p҂
    		for(Loop = 0; Loop < 200000; Loop++);
    	}
    	else if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_4) == 0)
    	{
    		// _p^[Zbg
    		State = Pattern_3;
    		// `^O΍p҂
    		for(Loop = 0; Loop < 200000; Loop++);
    	}
    	else if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_5) == 0)
    	{
    		// _p^[Zbg
    		State = Pattern_4;
    		// `^O΍p҂
    		for(Loop = 0; Loop < 200000; Loop++);
    	}
    	// eLEDɓ_p^[Zbg
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_1, State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, State);
    	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, State);
    }
}