#include "inc/hw_memmap.h"
#include "inc/hw_types.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/adc.h"

// {[͂ɂ郌x[^
int main(void)
{
	// ҂ԗp
	volatile unsigned long Loop;
	// A/Dϊli[p
	unsigned long data;
	// LED_p^[
	char State;
	// NbN̐ݒ
    SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |
                   SYSCTL_XTAL_6MHZ); 
    // gp|[g̐錾@LEDpɃ|[gCƃ|[gDgp
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);   
	// ADC0̎gp錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
    // PD0~PD6,PC7ꂼo̓^Cvɐݒ
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_1);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_2);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_5);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_7);
    // gpADC̎w
    ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
    // ADC̐ݒ
    ADCSequenceStepConfigure(ADC0_BASE, 3, 0,
                             ADC_CTL_CH1 | ADC_CTL_IE | ADC_CTL_END);
    // ADC0Lɂ
    ADCSequenceEnable(ADC0_BASE, 3);
	
    while(1)
    {
    	// A/DϊJn
    	ADCProcessorTrigger(ADC0_BASE, 3);
    	// A/Dϊl̎擾
    	ADCSequenceDataGet(ADC0_BASE, 3, &data);
    	// A/Dlɂē_p^[ݒ
    	if (data < 128)
    	{
    		// LED1_
    		State = 0x01;
    	}
    	else if (data < 256)
    	{
    		// LED2_
    		State = 0x03;
    	}
    	else if (data < 384)
    	{
    		// LED3_
    		State = 0x07;	
    	}
    	else if (data < 512)
    	{
    		// LED4_
    		State = 0x0F;
    	}
    	else if (data < 640)
    	{
    		// LED5_
    		State = 0x1F;
    	}
    	else if (data < 768)
    	{
    		// LED6_
    		State = 0x3F;
    	}
    	else if (data < 896)
    	{
    		// LED7_
    		State = 0x7F;
    	}
    	else
    	{
    		// LED8_
    		State = 0xFF;
    	}
    	// LEDɓ_p^[o
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, ~State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_1, ~State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, ~State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, ~State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, ~State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, ~State);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, ~State);
    	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, ~State);
    	// ҂
    	for(Loop = 0; Loop < 20000; Loop++);
    }
}
