#include <string.h>
#include <stdlib.h>
#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/systick.h"
#include "driverlib/interrupt.h"
#include "driverlib/timer.h"
#include "driverlib/adc.h"
#include "driverlib/pwm.h"

// ҂ԗp
volatile long g_cnt = 0;

// 荞ݏ
void SysTickHandler(void)
{
	// g_cntfNg(-1)
	g_cnt--;
}

// ԑ҂
void DelayMs( unsigned long ms )
{
	// JEgiԁjZbg
	g_cnt = ms;
	// SysTickLiJEgJnj
	SysTickEnable();
	// g_cnt0菬Ȃ܂Ń[vi݃[`g_cntfNgj
	while ( g_cnt > 0 );
	// SysTick~(JEg~)
	SysTickDisable();
}

// LCD̏
void lcd_init( void )
{
	// 30mb҂
	DelayMs(30);
	// RSMo
	GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, 0x00);
    // 15mb҂
    DelayMs(15);
	// LCD̃[h8rbg[hɐݒ
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x0C);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 5mb҂
	DelayMs(5);
	// ēx8rbg[hɐݒ
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x0C);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 1mb҂
	DelayMs(1);
	// āXx8rbg[hɐݒ
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x0C);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 5mb҂
	DelayMs(5);
	// 4rbg[hɐݒ
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x08);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 1mb҂
	DelayMs(1);
	// t@NVݒ i4rbg[h1/6DutyA5~7hbgŕ\j
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x08);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x20);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 1mb҂
	DelayMs(1);
	// fBXvC\OFF
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x00);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x20);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 1mb҂
	DelayMs(1);
	// fBXvC\ON iJ[\OFF uNOFFj
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x00);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x30);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 1mb҂
	DelayMs(1);
	// Gg[[h̐ݒ@i݂ŃAhX+1 \VtgȂj
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x00);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, 0x18);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 1mb҂
	DelayMs(1);	
}

// LCDւ̃f[^]
void lcd_write( unsigned char data )
{
	// Vtgpϐ
	char temp;
	
	// 4rbgMpVtg
	temp = ((GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_6) << 7) + data);
	temp = temp >> 2;
	// 4rbgf[^o
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, temp);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 4rbgMpVtg
	temp = ((GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_6) << 7) + (data << 4));
	temp = temp >> 2;
	// 4rbgf[^o
	GPIOPinWrite(GPIO_PORTA_BASE, GPIO_PIN_2 | GPIO_PIN_3 | GPIO_PIN_4 | GPIO_PIN_5, temp);
	// EMo
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0x00);
	// 1mb҂
	DelayMs(1);
}

// LCD\eNA
void lcd_clear( void )
{
	// RSMo
	GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, 0x00);
	// NA
	lcd_write(1);
	// 2mb҂	
	DelayMs(2);
}

// LCDւ̕\
void lcd_disp( char* s )
{
	// RSMo
	GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, GPIO_PIN_6);
	// f[^o
	while ( *s ){
		lcd_write(*s++);
	}
	// 1mb҂
	DelayMs(1);
}

// s
void lcd_NewLine (void)
{
	// RSMo
	GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, 0x00);
	// s
	lcd_write(0xC0);
	// 2mb҂
	DelayMs(2);
}

// LCD̃J[\z[
void lcd_Home (void)
{
	// RSMo
	GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_6, 0x00);
	// J[\z[ɂ閽
	lcd_write(0x80);
	// 2mb҂
	DelayMs(2);
}

// {[ɂ郂[^x{LCDA/Dlƃf[eB[\B
void main(void)
{	
	// A/Dϊli[p
	unsigned long data;
	// ݒpϐ
	unsigned long ulPeriod;
	// ҂ԗp
	volatile unsigned long Loop;
	// lϊp
	char temp[2] = "0";
	// LCDւ̏o͕
	char text_1[17];
	char text_2[17];
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_6MHZ);
    
    // gp|[g̑I@̓|[gA,|[gB,|[gC,|[gEI(LCD̐)
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
    // ADC0̎gp錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
    // PWM@\̎gp錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM);
    // ^C}[0gp邱Ƃ錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);
    
    // PA2~5,PB6,PC6o̓^Cvɐݒ
    GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_2);
    GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE, GPIO_PIN_5);
    GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_6);
    
    // gpADC̎w
    ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
    // ADC̐ݒ
    ADCSequenceStepConfigure(ADC0_BASE, 3, 0, ADC_CTL_CH1 | ADC_CTL_IE | ADC_CTL_END);
    // ADC0Lɂ
    ADCSequenceEnable(ADC0_BASE, 3);
    
    // PWM@\Ŏg|[g̎w
    GPIOPinTypePWM(GPIO_PORTE_BASE, GPIO_PIN_0);
    GPIOPinTypePWM(GPIO_PORTE_BASE, GPIO_PIN_1);
    // PWM̎w 1[ms]
    ulPeriod = SysCtlClockGet() / 1000;
	// PWMWFl[^[̐ݒ
    PWMGenConfigure(PWM_BASE, PWM_GEN_2, PWM_GEN_MODE_UP_DOWN | PWM_GEN_MODE_NO_SYNC);
    // PWMWFl[^[̎ݒ
    PWMGenPeriodSet(PWM_BASE, PWM_GEN_2, ulPeriod);
	// PWM̃f[eB[̎w
    PWMPulseWidthSet(PWM_BASE, PWM_OUT_4, ulPeriod * 9 / 10);
    PWMPulseWidthSet(PWM_BASE, PWM_OUT_5, ulPeriod * 9 / 10);
    // PWM4̏o͂,PWM5̏o͂s
    PWMOutputState(PWM_BASE, PWM_OUT_4_BIT, true);
    PWMOutputState(PWM_BASE, PWM_OUT_5_BIT, false);
    // PWMJn
	PWMGenEnable(PWM_BASE, PWM_GEN_2);
	
    // SysTick̊荞݂Ԋuݒ
    SysTickPeriodSet(SysCtlClockGet()/1000);
    // 荞ݎɌĂяoi֐jw
    SysTickIntRegister(SysTickHandler);
    
    // LCD
    lcd_init();
    // LCD\eNA
    lcd_clear();
	
    while(1)
    {
    	// \̗p
    	strcpy(text_1, "A/D  ");
    	strcpy(text_2, "Duty ");
    	// A/DϊJn
    	ADCProcessorTrigger(ADC0_BASE, 3);
    	// A/Dϊl̎擾
    	ADCSequenceDataGet(ADC0_BASE, 3, &data);
    	for(Loop = 0; Loop < 20000; Loop++);
    	// A/Dϊ̒lɉăf[eB[ύX
    	PWMPulseWidthSet(PWM_BASE, PWM_OUT_4, ulPeriod * data / 1024);
    	// 1A/Dl̐ʂǉ
    	temp[0] = 0x30 + (data/1000);
    	strcat(text_1, temp);
    	// 1A/Dl̕Sʂǉ
    	temp[0] = 0x30 + ((data%1000)/100);
    	strcat(text_1, temp);
    	// 1A/Dl̏\ʂǉ
    	temp[0] = 0x30 + (((data%1000)%100)/10);
    	strcat(text_1, temp);
    	// 1A/Dl̈ʂǉ
    	temp[0] = 0x30 + (((data%1000)%100)%10);
    	strcat(text_1, temp);
    	// 2Ƀf[eB[̕Sʂǉ
    	temp[0] = 0x30 + (((data*100)/1024)/100);
    	strcat(text_2, temp);
    	// 2Ƀf[eB[̏\ʂǉ
    	temp[0] = 0x30 + ((((data*100)/1024)%100)/10);
    	strcat(text_2, temp);
    	// 2Ƀf[eB[̈ʂǉ
    	temp[0] = 0x30 + ((((data*100)/1024)%100)%10);
    	strcat(text_2, temp);
    	// 2Ɂu%vǉ
    	strcat(text_2, "%");
    	// LCDɕ\
    	lcd_disp(text_1);
    	// s
    	lcd_NewLine();
    	// LCDɕ\
    	lcd_disp(text_2);
    	// J[\z[
    	lcd_Home();
    }
}
