#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"

// LED_/p}N
#define ON 0x00
#define OFF 0xFF

// LED_/
void main(void)
{	
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |
                   SYSCTL_XTAL_6MHZ);
    
    // gp|[g̐錾@LEDpɃ|[gCƃ|[gDgp
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
    
    // PD0`PD6,PC7ꂼo̓^Cvɐݒ
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_1);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_2);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_3);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_4);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_5);
    GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_6);
    GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_7);
    
    // [v
    while(1)
    {
    	// LEDON/OFF
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, ON);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_1, OFF);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, ON);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, OFF);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_4, ON);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_5, OFF);
    	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_6, ON);
    	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, OFF);
    }
}
